CreateStartScripts (Gradle API 9.5.0)
Description: declaration: package: org.gradle.jvm.application.tasks, class: CreateStartScripts

Package org.gradle.jvm.application.tasks

# Class CreateStartScripts

java.lang.Object
org.gradle.api.internal.AbstractTask
org.gradle.api.DefaultTask
org.gradle.api.internal.ConventionTask
org.gradle.jvm.application.tasks.CreateStartScripts

All Implemented Interfaces:
  `Comparable<Task>`, `org.gradle.api.internal.DynamicObjectAware`, `org.gradle.api.internal.IConventionAware`, `org.gradle.api.internal.TaskInternal`, `Named`, `ExtensionAware`, `Task`, `Configurable<Task>`

Direct Known Subclasses:
  `CreateStartScripts`

@DisableCachingByDefault(because="Not worth caching") public abstract class CreateStartScripts extends org.gradle.api.internal.ConventionTask
Creates start scripts for launching JVM applications.

Example:

     task createStartScripts(type: CreateStartScripts) {
       outputDir = file('build/sample')
       mainClass = 'org.gradle.test.Main'
       applicationName = 'myApp'
       classpath = files('path/to/some.jar')
     }

Note: the Gradle `"application"` plugin adds a pre-configured task of this type named `"startScripts"`.

The task generates separate scripts targeted at Microsoft Windows environments and UNIX-like environments (e.g. Linux, macOS). The actual generation is implemented by the `getWindowsStartScriptGenerator()` and `getUnixStartScriptGenerator()` properties, of type `ScriptGenerator`.

Example:

     task createStartScripts(type: CreateStartScripts) {
       unixStartScriptGenerator = new CustomUnixStartScriptGenerator()
       windowsStartScriptGenerator = new CustomWindowsStartScriptGenerator()
     }

     class CustomUnixStartScriptGenerator implements ScriptGenerator {
       void generateScript(JavaAppStartScriptGenerationDetails details, Writer destination) {
         // implementation
       }
     }

     class CustomWindowsStartScriptGenerator implements ScriptGenerator {
       void generateScript(JavaAppStartScriptGenerationDetails details, Writer destination) {
         // implementation
       }
     }

The default generators are of the type `TemplateBasedScriptGenerator`, with default templates. This templates can be changed via the `TemplateBasedScriptGenerator.setTemplate(TextResource)` method.

The default implementations used by this task use Groovy's SimpleTemplateEngine to parse the template, with the following variables available:

- `applicationName` - See `JavaAppStartScriptGenerationDetails.getApplicationName()`.
- `gitRef` - See `JavaAppStartScriptGenerationDetails.getGitRef()`.
- `optsEnvironmentVar` - See `JavaAppStartScriptGenerationDetails.getOptsEnvironmentVar()`.
- `exitEnvironmentVar` - See `JavaAppStartScriptGenerationDetails.getExitEnvironmentVar()`.
- `moduleEntryPoint` - The module entry point, or `null` if none. Will also include the main class name if present, in the form `[moduleName]/[className]`.
- `mainClassName` - The main class name, or usually `""` if none. For legacy reasons, this may be set to `--module [moduleEntryPoint]` when using a main module. This behavior should not be relied upon and may be removed in a future release.
- `entryPointArgs` - The arguments to be used on the command-line to enter the application, as a joined string. It should be inserted before the program arguments.
- `defaultJvmOpts` - See `JavaAppStartScriptGenerationDetails.getDefaultJvmOpts()`.
- `appNameSystemProperty` - See `JavaAppStartScriptGenerationDetails.getAppNameSystemProperty()`.
- `appHomeRelativePath` - The path, relative to the script's own path, of the app home.
- `classpath` - See `JavaAppStartScriptGenerationDetails.getClasspath()`. It is already encoded as a joined string.
- `modulePath` (different capitalization) - See `JavaAppStartScriptGenerationDetails.getModulePath()`. It is already encoded as a joined string.

The encoded paths expect a variable named `APP_HOME` to be present in the script, set to the application home directory which can be resolved using `appHomeRelativePath`.

Example:

     task createStartScripts(type: CreateStartScripts) {
       unixStartScriptGenerator.template = resources.text.fromFile('customUnixStartScript.txt')
       windowsStartScriptGenerator.template = resources.text.fromFile('customWindowsStartScript.txt')
     }

- ## Nested Class Summary

  ## Nested classes/interfaces inherited from interface org.gradle.api.Named

  `Named.Namer`

- ## Field Summary

  ### Fields inherited from interface org.gradle.api.Task

  `TASK_ACTION, TASK_CONSTRUCTOR_ARGS, TASK_DEPENDS_ON, TASK_DESCRIPTION, TASK_GROUP, TASK_NAME, TASK_OVERWRITE, TASK_TYPE`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `CreateStartScripts()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `generate()`
  `@Nullable String`
  `getApplicationName()`
  The application's name.
  `@Nullable FileCollection`
  `getClasspath()`
  The class path for the application.
  `@Nullable Iterable<String>`
  `getDefaultJvmOpts()`
  The application's default JVM options.
  `String`
  `getExecutableDir()`
  The directory to write the scripts into in the distribution.
  `@Nullable String`
  `getExitEnvironmentVar()`
  Deprecated.
  No longer used in the default start script templates.
  `abstract Property<String>`
  `getGitRef()`
  The Git revision or tag.
  `protected abstract org.gradle.internal.jvm.JavaModuleDetector`
  `getJavaModuleDetector()`
  `abstract Property<String>`
  `getMainClass()`
  The main class name used to start the Java application.
  `abstract Property<String>`
  `getMainModule()`
  The main module name used to start the modular Java application.
  `ModularitySpec`
  `getModularity()`
  Returns the module path handling for executing the main class.
  `protected abstract ObjectFactory`
  `getObjectFactory()`
  `@Nullable String`
  `getOptsEnvironmentVar()`
  The environment variable to use to provide additional options to the JVM.
  `@Nullable File`
  `getOutputDir()`
  The directory to write the scripts into.
  `protected Iterable<String>`
  `getRelativeClasspath()`
  `File`
  `getUnixScript()`
  Returns the full path to the Unix script.
  `ScriptGenerator`
  `getUnixStartScriptGenerator()`
  The UNIX-like start script generator.
  `File`
  `getWindowsScript()`
  Returns the full path to the Windows script.
  `ScriptGenerator`
  `getWindowsStartScriptGenerator()`
  The Windows start script generator.
  `void`
  `setApplicationName(@Nullable String applicationName)`
  `void`
  `setClasspath(@Nullable FileCollection classpath)`
  `void`
  `setDefaultJvmOpts(@Nullable Iterable<String> defaultJvmOpts)`
  `void`
  `setExecutableDir(String executableDir)`
  The directory to write the scripts into in the distribution.
  `void`
  `setExitEnvironmentVar(@Nullable String exitEnvironmentVar)`
  Deprecated.
  `void`
  `setOptsEnvironmentVar(@Nullable String optsEnvironmentVar)`
  `void`
  `setOutputDir(@Nullable File outputDir)`
  `void`
  `setUnixStartScriptGenerator(ScriptGenerator unixStartScriptGenerator)`
  `void`
  `setWindowsStartScriptGenerator(ScriptGenerator windowsStartScriptGenerator)`

  ### Methods inherited from class org.gradle.api.internal.ConventionTask

  `conventionMapping, conventionMapping, getConventionMapping`

  ### Methods inherited from class org.gradle.api.DefaultTask

  `compareTo, configure, dependsOn, doFirst, doFirst, doFirst, doLast, doLast, doLast, finalizedBy, getActions, getAnt, getDependsOn, getDescription, getDestroyables, getDidWork, getEnabled, getExtensions, getFinalizedBy, getGroup, getInputs, getLocalState, getLogger, getLogging, getMustRunAfter, getName, getOutputs, getPath, getProject, getShouldRunAfter, getState, getTaskDependencies, getTemporaryDir, getTimeout, hasProperty, mustRunAfter, onlyIf, onlyIf, onlyIf, property, setActions, setDependsOn, setDescription, setDidWork, setEnabled, setFinalizedBy, setGroup, setMustRunAfter, setOnlyIf, setOnlyIf, setOnlyIf, setProperty, setShouldRunAfter, shouldRunAfter, usesService`

  ### Methods inherited from class org.gradle.api.internal.AbstractTask

  `acceptServiceReferences, appendParallelSafeAction, doNotTrackState, doNotTrackStateIf, getAsDynamicObject, getIdentityPath, getImpliesSubProjects, getLifecycleDependencies, getOnlyIf, getReasonNotToTrackState, getReasonsNotToTrackState, getReasonTaskIsIncompatibleWithConfigurationCache, getRequiredServices, getServices, getSharedResources, getStandardOutputCapture, getTaskActions, getTaskIdentity, getTemporaryDirFactory, hasTaskActions, injectIntoNewInstance, isCompatibleWithConfigurationCache, isEnabled, isHasCustomActions, notCompatibleWithConfigurationCache, prependParallelSafeAction, restoreOnlyIf, restoreTaskActions, setImpliesSubProjects`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

  ### Methods inherited from interface org.gradle.api.Task

  `doNotTrackState, notCompatibleWithConfigurationCache`

- ## Constructor Details

  - ### CreateStartScripts

    public CreateStartScripts()

- ## Method Details

  - ### getObjectFactory

    @Inject protected abstract ObjectFactory getObjectFactory()

  - ### getJavaModuleDetector

    @Inject protected abstract org.gradle.internal.jvm.JavaModuleDetector getJavaModuleDetector()

  - ### getOptsEnvironmentVar

    @Optional @Input public @Nullable String getOptsEnvironmentVar()
    The environment variable to use to provide additional options to the JVM.

  - ### getExitEnvironmentVar

    @Optional @Input @Deprecated public @Nullable String getExitEnvironmentVar()
    Deprecated.
    No longer used in the default start script templates. Will be removed in Gradle 10.
    The environment variable to use to control exit value (Windows only).

  - ### getUnixScript

    @Internal public File getUnixScript()
    Returns the full path to the Unix script. The target directory is represented by the output directory, the file name is the application name without a file extension.

  - ### getWindowsScript

    @Internal public File getWindowsScript()
    Returns the full path to the Windows script. The target directory is represented by the output directory, the file name is the application name plus the file extension .bat.

  - ### getOutputDir

    @OutputDirectory public @Nullable File getOutputDir()
    The directory to write the scripts into.

  - ### setOutputDir

    public void setOutputDir(@Nullable File outputDir)

  - ### getExecutableDir

    @Input public String getExecutableDir()
    The directory to write the scripts into in the distribution.
    Since:
      4.5

  - ### setExecutableDir

    public void setExecutableDir(String executableDir)
    The directory to write the scripts into in the distribution.
    Since:
      4.5

  - ### getMainModule

    @Optional @Input public abstract Property<String> getMainModule()
    The main module name used to start the modular Java application.
    Since:
      6.4

  - ### getMainClass

    @Optional @Input public abstract Property<String> getMainClass()
    The main class name used to start the Java application.
    Since:
      6.4

  - ### getDefaultJvmOpts

    @Optional @Input public @Nullable Iterable<String> getDefaultJvmOpts()
    The application's default JVM options. Defaults to an empty list.

  - ### setDefaultJvmOpts

    public void setDefaultJvmOpts(@Nullable Iterable<String> defaultJvmOpts)

  - ### getApplicationName

    @Input public @Nullable String getApplicationName()
    The application's name.

  - ### setApplicationName

    public void setApplicationName(@Nullable String applicationName)

  - ### getGitRef

    @Incubating @Optional @Input public abstract Property<String> getGitRef()
    The Git revision or tag.
    Since:
      9.4.0

  - ### setOptsEnvironmentVar

    public void setOptsEnvironmentVar(@Nullable String optsEnvironmentVar)

  - ### setExitEnvironmentVar

    @Deprecated public void setExitEnvironmentVar(@Nullable String exitEnvironmentVar)
    Deprecated.

  - ### getClasspath

    @Classpath @Optional public @Nullable FileCollection getClasspath()
    The class path for the application.

  - ### getModularity

    public ModularitySpec getModularity()
    Returns the module path handling for executing the main class.
    Since:
      6.4

  - ### setClasspath

    public void setClasspath(@Nullable FileCollection classpath)

  - ### getUnixStartScriptGenerator

    public ScriptGenerator getUnixStartScriptGenerator()
    The UNIX-like start script generator.

    Defaults to an implementation of `TemplateBasedScriptGenerator`.

  - ### setUnixStartScriptGenerator

    public void setUnixStartScriptGenerator(ScriptGenerator unixStartScriptGenerator)

  - ### getWindowsStartScriptGenerator

    public ScriptGenerator getWindowsStartScriptGenerator()
    The Windows start script generator.

    Defaults to an implementation of `TemplateBasedScriptGenerator`.

  - ### setWindowsStartScriptGenerator

    public void setWindowsStartScriptGenerator(ScriptGenerator windowsStartScriptGenerator)

  - ### generate

    public void generate()

  - ### getRelativeClasspath

    @Input protected Iterable<String> getRelativeClasspath()